package org.apache.bcel.verifier;

import org.apache.commons.lang3.ArrayUtils;
import java.util.ArrayList;
import java.util.List;

public abstract class PassVerifier
{
    private final List<String> messages;
    private VerificationResult verificationResult;
    
    public PassVerifier() {
        this.messages = new ArrayList<String>();
    }
    
    public void addMessage(final String message) {
        this.messages.add(message);
    }
    
    public abstract VerificationResult do_verify();
    
    public String[] getMessages() {
        return this.getMessagesList().toArray(ArrayUtils.EMPTY_STRING_ARRAY);
    }
    
    public List<String> getMessagesList() {
        this.verify();
        return this.messages;
    }
    
    public VerificationResult verify() {
        if (this.verificationResult == null) {
            this.verificationResult = this.do_verify();
        }
        return this.verificationResult;
    }
}
